/*****
 * imi i nazwisko: Tomasz Guz
 * grupa studencka: T-SST
 * temat: ZAD37 - biblioteka standardowa: wizanie strumieni (tie)
 * 
 * Opis dziaania i uytkowania:
 * 
 * Wizanie strumieni dostpne jest za pomoc funkcji skadowych 
 * klasy ios:
 * 
 * ostream * tie(ostream *) ;	<- dziki tej funkcji moliwe jest 
 * zwizanie strumienia z jakim strumieniem wyjciowym. Argumentem 
 * funkcji jest wskanik na strumie wyjciowy, ktry chcemy dowiza.
 * Wartoci zwracan jest wskanik na strumie, ktry dotychczas by
 * dowizany do danego strumienia.
 * 
 * ostream * tie() ; 	<- ta funkcja zwraca wskanik do strumienia 
 * wyjciowego, z ktrym obecnie dany strumie jest powizany. 
 * 
 * Wizanie strumieni sprawia, e przed wykonaniem operacji we/wy na 
 * strumieniach, do ktrych dany strumie wyjciowy (tylko strumie
 * wyjciowy moe zosta w ten sposb dowizany) zosta dowizany,
 * zostanie wyprniony bufor dowizanego strumienia wyjciowego.
 * 
 * Przykad:  
 *****/

#include <iostream>
#include <fstream>
#include <string>

using namespace std;

int main(int argc, char** argv)
{
	char str[255];
	char buffer[1024];
	
	ofstream ofs;
	ifstream ifs;
	
	//otwarcie tego samego pliku do:
	ifs.open("test1.txt");	//odczytu
	ofs.open("test1.txt");	//i zapisu
	
	cout << "Otworzono plik: test1.txt" << endl;
	
	//zwikszenie bufora strumienia zapisujcego do pliku
	//w celu uzyskania buforowania zapisu
	ofs.rdbuf()->pubsetbuf(buffer, 1024);

	ofs << "Ala";
	cout << "Do pliku dopisano: 'Ala'" << endl;
	
	cout << "Strumien ifstream odczytal z pliku: '";
	while(ifs){
		ifs.getline(str, 255);
		cout << str;
	}
	cout << "'" << endl;
	
	ofs << " ma kota";
	cout << "Do pliku dopisano: ' ma kota'" << endl;

	ofs.close();
	ifs.close();
	
	getchar();
	
	ifs.open("test2.txt");
	ofs.open("test2.txt");
	
	cout << "Otworzono plik test2.txt, strumien ifstream powiazano z ofstream" << endl;
	
	//Powiazanie strumienia ifs z ofs. Teraz przed czytaniem zawartosci
	//pliku najpierw zostanie oprniony bufor strumienia ofs, czyli
	//zapis do pliku
	ifs.tie(&ofs);
	
	ofs << "Ala";
	cout << "Do pliku dopisano: 'Ala'" << endl;
	
	cout << "Po dowiazaniu strumien ifstream odczytal z pliku: '";
	while(ifs){
		ifs.getline(str, 255);
		cout << str;
	}
	cout << "'" << endl;
	
	ofs << " ma kota";
	cout << "Do pliku dopisano: ' ma kota'" << endl;
	
	ofs.close();
	ifs.close();
	
	getchar();
	
	return 0;
}
